package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.kelurahan;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "KELURAHAN".
*/
public class kelurahanDao extends AbstractDao<kelurahan, Long> {

    public static final String TABLENAME = "KELURAHAN";

    /**
     * Properties of entity kelurahan.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Kecamatan_id = new Property(1, String.class, "kecamatan_id", false, "KECAMATAN_ID");
        public final static Property Nama = new Property(2, String.class, "nama", false, "NAMA");
    };


    public kelurahanDao(DaoConfig config) {
        super(config);
    }
    
    public kelurahanDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"KELURAHAN\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"KECAMATAN_ID\" TEXT," + // 1: kecamatan_id
                "\"NAMA\" TEXT);"); // 2: nama
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"KELURAHAN\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, kelurahan entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String kecamatan_id = entity.getKecamatan_id();
        if (kecamatan_id != null) {
            stmt.bindString(2, kecamatan_id);
        }
 
        String nama = entity.getNama();
        if (nama != null) {
            stmt.bindString(3, nama);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public kelurahan readEntity(Cursor cursor, int offset) {
        kelurahan entity = new kelurahan( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // kecamatan_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2) // nama
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, kelurahan entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setKecamatan_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setNama(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(kelurahan entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(kelurahan entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
